//--------------------------------------------------------
//MyTypeDefs.h : header file for the HexBootLoade project
//--------------------------------------------------------

#ifndef _MYTYPEDEFS_H_
#define _MYTYPEDEFS_H_

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <stdlib.h>
#include <string.h>
#include <util/delay.h>


//----------------------------------------------------------
// Macros to access strings defined in PROGMEM above 64kB
//----------------------------------------------------------


#define FAR(var)  \
({                                                 \
    uint_farptr_t tmp;                             \
                                                   \
    __asm__ __volatile__(                          \
                                                   \
            "ldi    %A0, lo8(%1)"           "\n\t" \
            "ldi    %B0, hi8(%1)"           "\n\t" \
            "ldi    %C0, hh8(%1)"           "\n\t" \
            "clr    %D0"                    "\n\t" \
        :                                          \
            "=d" (tmp)                             \
        :                                          \
            "p"  (&(var))                          \
    );                                             \
    tmp;                                           \
})



//------------------------------------------------
// Definition of types
//------------------------------------------------

typedef signed char        s08;
typedef signed int         s16;
typedef signed long        s32;
typedef signed long long   s64;
typedef unsigned char      u08;
typedef unsigned int       u16;
typedef unsigned long      u32;
typedef unsigned long long u64;


#endif
